#! /usr/bin/env python3 -B

from testlib import check, runtests, check_text_file,  check_img_file
import program

###############################################################################
def test_es7a_1():
    ''' \nProva con l'immagine 'scacchiera.png' e i colori in 'fcolori1.txt' '''
    expected = 7500
    explanation = "il valore restituito non   e' corretto"
    ris = program.es7('scacchiera.png', 'fcolori1.txt', 'out1.png')
    check(ris, expected, None, explanation)
    check_img_file('out1.png', 'scacchieraOut1.png')
    return 1


def test_es7a_2():
    ''' \nProva con l'immagine 'scacchiera.png' e i colori in 'fcolori2.txt' '''
    expected = 4804
    explanation = "il valore restituito non   e' corretto"
    ris = program.es7('scacchiera.png', 'fcolori2.txt', 'out2.png')
    check(ris, expected, None, explanation)
    check_img_file('out2.png', 'scacchieraOut2.png')
    return 1


def test_es7a_3():
    ''' \nProva con l'immagine 'cubo.png' e i colori in 'fcolori3.txt' '''
    expected = 10620
    explanation = "il valore restituito non   e' corretto"
    ris = program.es7('cubo.png', 'fcolori3.txt', 'out3.png')
    check(ris, expected, None, explanation)
    check_img_file('out3.png', 'cuboOut.png')
    return 1


################################################################################


def test_es8a_1():
    ''' \nProva con il file 'finteri1.txt' '''
    expected = [10, 10, 15]
    explanation = "la lista  restituita non  e' corretta"
    ris = program.es8('finteri1.txt')
    check(ris, expected, None, explanation)
    return 1


def test_es8a_2():
    ''' \nProva con il file 'finteri2.txt' '''
    expected = [7, 9, 9, 7, 3, 6]
    explanation = "la lista  restituita non  e' corretta"
    ris = program.es8('finteri2.txt')
    check(ris, expected, None, explanation)
    return 1


def test_es8a_3():
    ''' \nProva con con il file 'finteri3.txt' '''
    expected = [191, 163, 132, 98, 61, 21]
    explanation = "la lista  restituita non  e' corretta"
    ris = program.es8('finteri3.txt')
    check(ris, expected, None, explanation)
    return 1


################################################################################

def test_es9a_1():
    ''' \nProva con con a=20 e b=2 '''
    expected = {2, 3, 67, 5, 37, 7, 71, 41, 11, 43, 13, 47, 17, 19, 61, 53, 23, 59, 29, 31}
    explanation = "l'insieme restituito non e' corretto"
    ris = program.es9(20, 2)
    check(ris, expected, None, explanation)
    return 2


def test_es9a_2():
    ''' \nProva con a=10 e b=3 '''
    expected = {289, 4, 9, 169, 361, 841, 49, 529, 121, 25}
    explanation = "l'insieme restituito non e' corretto"
    ris = program.es9(10, 3)
    check(ris, expected, None, explanation)
    return 2


def test_es9a_3():
    ''' \nProva con a=10 e b=4 '''
    expected = {33, 6, 8, 10, 14, 15, 21, 22, 26, 27}
    explanation = "l'insieme restituito non e' corretto"
    ris = program.es9(10, 4)
    check(ris, expected, None, explanation)
    return 2


################################################################################

def test_es12a_1():
    ''' \nProva con  parola1='aabbccdd' parola2='acccdzza' '''
    expected= ['a','c','cc','ccd','cd','d']
    explanation = "la lista restituita non e' corretta"
    ris    = program.es12('aabbccdd','acccdzza')
    check(ris,expected,None,explanation)
    return 2

def test_es12a_2():
    ''' \nProva con parola1='python2' parola2='python3' '''
    expected= ['h', 'ho', 'hon', 'n', 'o', 'on', 'p', 'py', 'pyt', 'pyth', 
    'pytho', 'python', 't', 'th', 'tho', 'thon', 'y', 'yt', 'yth', 'ytho', 'ython']
    explanation = "la lista restituita non e' corretta"
    ris    = program.es12('python2', 'python3')
    check(ris,expected,None,explanation)
    return 2
    
def test_es12a_3():
    ''' \nProva con parola1='fondamenti_di_programmazione' parola2='progettazione_di_algoritmi' '''
    expected= ['_', '_d', '_di', '_di_', 'a', 'az', 'azi', 'azio', 'azion', 'azione', 
    'd', 'di', 'di_', 'e', 'g', 'i', 'i_', 'io', 'ion', 'ione', 'm', 'n', 'ne', 'o', 
    'og', 'on', 'one', 'p', 'pr', 'pro', 'prog', 'r', 'ro', 'rog', 't', 'z', 'zi', 
    'zio', 'zion', 'zione']
    explanation = "la lista restituita non e' corretta"
    ris    = program.es12('fondamenti_di_programmazione', 'progettazione_di_algoritmi')
    check(ris,expected,None,explanation)
    return 2

################################################################################

from isrecursive import *

def test_es13a(stringa, expected):
    decorate_module(program)
    try:
        program.es13(stringa)
    except RecursionDetectedError:
        pass
    else:
        raise Exception("Recursion not present")
    finally:
        undecorate_module(program)
    explanation = "la stringa restituita non e' corretta"
    ris    = program.es13(stringa)
    check(ris,expected,stringa,explanation)
    return 2

def test_es13a_1():
    ''' \nProva con parola='zzzcdcaaabvv'  '''
    expected= 'aaa'
    stringa = 'zzzcdcaaabvv'
    return test_es13a(stringa, expected)

def test_es13a_2():
    ''' \nProva con parola='adbbabbcbbaad' '''
    expected= 'abbcbba'
    stringa = 'adbbabbcbbaad'
    return test_es13a(stringa, expected)
    
def test_es13a_3():
    ''' \nProva con parola='monti_sterbini_spognardi' '''
    expected= 'ini'
    stringa = 'monti_sterbini_spognardi'
    return test_es13a(stringa, expected)

################################################################################

def test_es15a_1():
    ''' \nProva con lista=[ 'uuu','ccc','a','aa','d','z','zzz','uuu','z','z','uuu']  '''
    expected     = ['z', 'd', 'a', 'aa', 'zzz', 'uuu', 'ccc']
    explanation1 = "la lista di input e' stata modificata"
    explanation2 = "la lista restituita non e' corretta"
    lista        = [ 'uuu','ccc','a','aa','d','z','zzz','uuu','z','z','uuu']
    ris          = program.es15(lista)
    check(ris,expected,None,explanation2)
    check(lista,[ 'uuu','ccc','a','aa','d','z','zzz','uuu','z','z','uuu'],None,explanation1)
    return 2

def test_es15a_2():
    ''' \nProva con lista=[ 'a','a','bb','bb','ccc','ccc','dddd','dddd','eeeee','eeeee']  '''
    expected     = ['a', 'bb', 'ccc', 'dddd', 'eeeee']
    explanation1 = "la lista di input e' stata modificata"
    explanation2 = "la lista restituita non e' corretta"
    lista2       = [ 'a','a','bb','bb','ccc','ccc','dddd','dddd','eeeee','eeeee']
    ris    = program.es15(lista2)
    check(ris,expected,None,explanation2)
    check(lista2,  [ 'a','a','bb','bb','ccc','ccc','dddd','dddd','eeeee','eeeee'] ,None,explanation1)
    return 2
    
def test_es15a_3():
    ''' \nProva con lista=[ 'a','b','c','d','rr','ss','ttt','uuu','vv','n','m','l']  '''
    expected     = ['n', 'm', 'l', 'd', 'c', 'b', 'a', 'vv', 'ss', 'rr', 'uuu', 'ttt']
    explanation1 = "la lista di input e' stata modificata"
    explanation2 = "la lista restituita non e' corretta"
    lista3       = [ 'a','b','c','d','rr','ss','ttt','uuu','vv','n','m','l']
    ris    = program.es15(lista3)
    check(ris,expected,None,explanation2)
    check(lista3,   [ 'a','b','c','d','rr','ss','ttt','uuu','vv','n','m','l'],None,explanation1)
    return 2

################################################################################



tests = [
    test_es7a_1, test_es7a_2, test_es7a_3,
    test_es8a_1, test_es8a_2, test_es8a_3,
    test_es9a_1, test_es9a_2, test_es9a_3,
    test_es12a_1, test_es12a_2, test_es12a_3,
    test_es13a_1, test_es13a_2, test_es13a_3,
    test_es15a_1, test_es15a_2, test_es15a_3,
]

if __name__ == '__main__':
    # runtests(tests)
    runtests(tests, logfile='grade.csv')
