'''
Progettate una o piu' delle seguenti funzioni
(all'inizio di ogni funzione viene specificato il numero di punti assegnato dal grader a quella funzione)
Il punteggio complessivo dato dal grader e' il voto della prova di recupero.
Se la somma dei punteggi ottenuti con gli esercizi e' maggiore di 32, si otterra' il punteggio 32.

NOTA: il grader testa tutte le funzioni, quindi stampera' degli errori per le funzioni non implementate
NOTA: e' VIETATO usare la funzione os.walk

!!!ATTENZIONE!!!: e' VIETATO aggiungere argomenti alle funzioni,
    (per evitare problemi con i valori di default mutabili)
    piuttosto usate delle funzioni di appoggio e passate loro gli argomenti aggiuntivi necessari
'''

###############################################################################################
import immagini

def es7(fImageIn, fcolori, fImageOut):
    '''
    Es. 7: 3 punti
    Si progetti la funzione es7(fImageIn, fcolori, fImageOut) che
    modifica il colore di alcuni pixel presenti in un imagine  PNG fImageIn  e salva poi l'immagine
    modificata  in un nuovo file PNG FImageOut.
    La funzione inoltre ritorna il numero di pixel dell'immagine i cui colori sono stati modificati.
    I colori da modificare sono specificati dal file di testo fcolori.
    Il file fcolori ha tante righe quanti sono i colori da modificare.
    Ogni riga di fcolori contiene  6 interi a valori tra 0 e 255.
    I primi tre indicano il colore da modificare
    e i secondi tre il nuovo colore
    Ad esempio la presenza eventuale della riga
    0 0 0  255 255 255
    indica che nell'immagine tutti  i pixel di colore nero ( i.e. di colore  (0,0,0)) devono
    assumere colore bianco (i.e. devono assumere colore (255,255,255)).

    NOTA: i colori devono essere sostituiti contemporaneamente
    (e non con una sostituzione alla volta che potrebbe modificare un pixel piu' volte)

    :param fImageIn: nome del file PNG contenente l'immagine da modificare
    :param fcolori: nome del file di testo in cui trovare i colori da modificare
    :param fImageOut: nome del file PNG in cui salvare l'immagine modificata
    :return: numero di pixel modificati
    '''
    # Mettete il vostro codice qui
    img = immagini.load(fImageIn)
    h = len(img)
    w = len(img[0])
    conteggio = 0
    palette = {}
    with open(fcolori) as f:
        for line in f:
            r, g, b, R, G, B = map(int, line.split())
            palette[(r, g, b)] = R, G, B
    for y in range(h):
        for x in range(w):
            c = img[y][x]
            if c in palette:
                img[y][x] = palette[c]
                conteggio += 1
    immagini.save(img, fImageOut)
    return conteggio


############################################################################################
def es8(ftesto):
    '''
    Es. 8: 3 punti
    Si progetti la funzione es8(ftesto) che, preso in input l'indirizzo di un file di testo
    contenente righe contenenti interi separati da spazi, restituisce una lista  di interi.
    La lunghezza della lista e' data dal numero massimo di interi che compaiono nelle righe
    del file. E nella generica posizione i della lista c'e' l'intero corrispondente alla somma di tutti
    gli interi presenti in posizione  i  nelle varie righe che contengono almeno i interi.
    Ad esempio per il file contenente le  3 righe:
    ' 0 2  4
      6 8 10
      4 0  1'
    la funzione restituisce la lista [10,10,15] cioe' le somme in colonna
    Per il file contenente le  4 righe (nota, di lunghezza diversa):
    ' 1 2 3
      4 5 6 7 3 6
      1
      1 2'
    la funzione restituisce la lista [7,9,9,7,3,6] cioe' le somme in colonna
    '''
    # Mettete il vostro codice qui
    somme = []
    with open(ftesto) as f:
        for line in f:
            interi = list(map(int, line.split()))
            for i, v in enumerate(interi):
                if i < len(somme):
                    somme[i] += v
                else:
                    for _ in range(i - len(somme)):
                        somme.append(0)
                    somme.append(v)
    return somme


############################################################################################
def es9(a, b):
    '''
    Es. 9: 6 punti
    Si progetti la funzione es9(a,b) che,  in input due interi a e b restituisce l'insieme dei primi
    a interi che hanno esattamente b divisori.
    Ad esempio per a=20 e b=2 la funzione deve restituire l'insieme dei primi 20 numeri primi
    (perche' solo i numeri primi hanno esattamente 2 divisori), vale a dire:
    {2, 3, 67, 5, 37, 7, 71, 41, 11, 43, 13, 47, 17, 19, 61, 53, 23, 59, 29, 31}
    '''
    # Mettete il vostro codice qui
    interi = set()
    n = 2
    while len(interi) < a:
        ndiv = 0
        for i in range(1, n + 1):
            if n % i == 0:
                ndiv += 1
            if ndiv > b:
                break
        if ndiv != b:
            n += 1
            continue
        else:
            interi.add(n)
        n += 1
    return interi


###############################################################################################
def es12(parola1,parola2):
    '''
    Es 12: 6 punti
    progettare la funzione es12(parola1,parola2) che
    prende in input due  stringhe di caratteri parola1 e parola2, e restituisce la lista delle
    sottostringhe che risultano in comune ad entrambe le parole.
    La lista delle sottostringhe comuni deve essere ordinata lessicograficamente e non deve contenere duplicati.
    Si ricorda che una sottostringa e' quello che si ottiene da una stringa
    eliminando 0 o piu' caratteri all'inizio e 0 o piu' caratteri alla fine

    Ad esempio:
    con  parola1='aabbccdd' parola2='acccdzza' la funzione restituisce la lista [a,c,cc,ccd,cd,d]
    '''
    sotto1 = set()
    sotto2 = set()
    l1 = len(parola1)
    for i in range(l1):
        for j in range(i, l1):
            sotto1.add(parola1[i:j+1])
    l2 = len(parola2)
    for i in range(l2):
        for j in range(i, l2):
            sotto2.add(parola2[i:j+1])
    return sorted(sotto1.intersection(sotto2))

###############################################################################################

def es13(parola):
    '''
    Es 13: 6 punti
    progettare la funzione es13(parola) che usa almeno una funzione ricorsiva e:
    - prende in input una stringa di caratteri parola e, tra tutte le sottostringhe di parola restituisce
    quella di lunghezza massima che risulti anche palindroma.
    In caso ci siano piu' palindromi a lunghezza massima viene restituita quella che precede lessicograficamente.
    Si ricorda che una sottostringa e' quello che si ottiene da una stringa
    eliminando 0 o piu' caratteri all'inizio e 0 o piu' caratteri alla fine mentre
    una stringa e' palindroma se puo' leggersi indifferentemente da sinistra a destra o viceversa.

    Ad esempio:
    con parola='zzzcdcaaabvv'  la funzione restituira' la stringa palindroma 'aaa'
    con parola='adbbabbcbbaad' la funzione restituira' la stringa palindroma 'abbcbba'
    '''
    sotto = set()
    l = len(parola)
    for i in range(l):
        for j in range(i,l):
            sotto.add(parola[i:j+1])
    sotto = sorted(sotto, key=lambda p: (-len(p), p))
    for p in sotto:
        if palindroma(p):
            return p

def palindroma(p):
    if len(p) < 2:
        return True
    else:
        return p[0]==p[-1] and palindroma(p[1:-1])

###############################################################################################
def es15(lista):
    '''
    Es 15: 6 punti
    progettare la funzione es15(lista) che
    prende in input una lista di stringhe, e restituisce una lista di stringhe.
    La lista da restituire e' quella che si ottiene dalla lista di input dopo averne eliminato i duplicati,
    e in cui le stringhe sono state ordinate per lunghezza crescente ed a parita' di lunghezza  per ordine
    lessicografico decrescente.
    Al termine della funzione la lista passata in input non deve risultare modificata.

    Ad esempio: per lista=[ 'uuu','ccc','a','aa','d','z','zzz','uuu','z','z','uuu']:
    e la funzione restituira' la lista
    ['z','d','a','aa','zzz','uuu','ccc']
    mentre la lista di input non risultera' modificata.
    '''
    return sorted(set(lista), key=lambda x: (-len(x), x), reverse=True)


###############################################################################################
